package net.jaekl.squelch.stmt;

import java.io.IOException;
import java.io.PrintWriter;
import java.sql.Connection;
import java.sql.SQLException;

/**
 * Abstract base class for all statements (e.g., Insert, Create, Delete, Describe)
 */

public abstract class Stmt {
	// Returns true iff. line represents an instance of this statement type
	abstract public boolean handles(String line);
	
	// Execute line as a statement of this type
	abstract public int exec(Connection conn, PrintWriter pw, String line) throws IOException, SQLException;
}
