package net.jaekl.squelch.util;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.InputStream;
import java.util.HashMap;

public class FileUtilMock extends FileUtil {
	private HashMap<String, Boolean> m_readable;
	private HashMap<String, FileMock> m_files;
	
	private FileUtilMock() {
		m_readable = new HashMap<String, Boolean>();
		m_files = new HashMap<String, FileMock>();
	}
	
	public static void mock_setInst() {
		synchronized(FileUtil.class) { 
			m_inst = new FileUtilMock();
		}
	}
	
	public static FileUtilMock mock_getInst() {
		FileUtil result = m_inst;
		if (result instanceof FileUtilMock) {
			return (FileUtilMock) m_inst;
		}
		throw new AssertionError("Mock not initialized?");
	}
	
	@Override
	public File newFile(String filename) {
		return mock_newFile(filename);
	}
	
	@Override
	public InputStream openStream(File file) throws FileNotFoundException {
		if (file instanceof FileMock) {
			return ((FileMock)file).mock_openStream();
		}
		return new FileInputStream(file);
	}
	
	public FileMock mock_newFile(String filename) {
		File file = new File(filename);
		String absFilename = file.getAbsolutePath();
		FileMock fileMock = m_files.get(absFilename);
		if (null == fileMock) {
			fileMock = new FileMock(filename);
			m_files.put(fileMock.getAbsolutePath(), fileMock);
		}
		return fileMock;		
	}
	
	public void mock_setReadable(File file, boolean readable) {
		m_readable.put(file.getAbsolutePath(), Boolean.valueOf(readable));
	}
	
	public boolean mock_canRead(FileMock fileMock) {
		Boolean readable = m_readable.get(fileMock.getAbsolutePath());
		if (null == readable) {
			return false;
		}
		
		return readable.booleanValue();
	}
}
